#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

($username,$webring,$method)=split("&",$ENV{QUERY_STRING});

if ($webring && $username && $method)
{
	$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT rname,stype,status,rurl FROM rw_rings,rw_users WHERE (rid=$webring AND rw_users.uid=rw_rings.uid)");
	($fullrn,$stype,$status,$rurl)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if ($fullrn)
	{
		if ($status==1)
		{
			$sth=$dbh->query("LOCK TABLES rw_users READ, rw_sites READ") if ($locktables);
			if ($stype==1)
			{
				$sth=$dbh->query("SELECT rw_sites.uid,surl FROM rw_sites,rw_users WHERE (rid=$webring AND rw_sites.uid=rw_users.uid AND status=1) ORDER BY sname");
			}
			else
			{
				$sth=$dbh->query("SELECT rw_sites.uid,surl FROM rw_sites,rw_users WHERE (rid=$webring AND rw_sites.uid=rw_users.uid AND status=1) ORDER BY RAND()");
			}
			while (($uid,$uurl)=$sth->fetchrow)
			{
				push(@ndata,"$uid\t$uurl");
			}
			$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		}
		elsif ($status==2)
		{
			&closedb;
			push(@result,"<li>Sorry, webring <b>$fullrn</b> is temporary disabled</li>");
			push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
			open (F,"<$rwpath/template/sitelist.tpl");
			@html=<F>;
			close (F);
			$html=join("",@html);
			$html="print qq~$html~;";
			print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
			print "content-type: text/html\n\n";
			eval $html;
			exit;
		}
		else
		{
			&closedb;
			push(@result,"<li>Sorry, webring <b>$fullrn</b> is not approved yet</li>");
			push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
			open (F,"<$rwpath/template/sitelist.tpl");
			@html=<F>;
			close (F);
			$html=join("",@html);
			$html="print qq~$html~;";
			print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
			print "content-type: text/html\n\n";
			eval $html;
			exit;
		}
	}
	else
	{
		&closedb;
		push(@result,"<li>Sorry, webring is not exits</li>");
		push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
		open (F,"<$rwpath/template/sitelist.tpl");
		@html=<F>;
		close (F);
		$html=join("",@html);
		$html="print qq~$html~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $html;
		exit;
	}
}
else
{
	&closedb;
	push(@result,"<li>Sorry, webring code on website you come from is broken</li>");
	push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
	open (F,"<$rwpath/template/sitelist.tpl");
	@html=<F>;
	close (F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
	exit;
}
if (@ndata)
{
	@data=@ndata;
	@ndata=();
	$i=0;
	while ($i<scalar(@data))
	{
		($uname)=split("\t",$data[$i]);
		if ($uname==$username)
		{
			$item=$i;
			last;
		}
		$i++;
	}
	$item=0 unless ($item);
	if ($item>0){$pitem=$item-1;}
	else {$pitem=scalar(@data)-1;}
	if ($item<(scalar(@data)-1)){$nitem=$item+1;}
	else {$nitem=0;}
	($puid,$purl)=split("\t",$data[$pitem]);
	($nuid,$nurl)=split("\t",$data[$nitem]);
	foreach (@data)
	{
		($title,$uurl)=split("\t",$_);
		next if ($title==$username);
		push (@ndata,$uurl);
	}
	if (@ndata)
	{
		srand;
		$rurl=$ndata[int(rand scalar(@ndata))];
	}
	else
	{
		$rurl=$furl unless ($rurl);
	}
	$redurl=$nurl if ($method eq "next");
	$redurl=$purl if ($method eq "prev");
	$redurl=$rurl if ($method eq "random");
}
else
{
	if ($rurl)
	{
		$redurl=$rurl;
	}
	else
	{
		$redurl=$furl;
	}
}
&closedb;
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $redurl\n\n";

sub closedb
{
$sth="";
$dbh="";
}
